import { jsx as l, jsxs as M, Fragment as C } from "react/jsx-runtime";
import { useFloating as x, useClick as N, useDismiss as S, useRole as R, useInteractions as y, useMergeRefs as P, FloatingPortal as $, FloatingOverlay as F, FloatingFocusManager as T } from "@floating-ui/react";
import I from "clsx";
import * as s from "react";
import { useId as v } from "react";
const b = s.createContext(null);
function k({
  initialOpen: e = !1,
  open: t,
  onOpenChange: n
} = {}) {
  const [o, i] = s.useState(e), [r, a] = s.useState(), [c, f] = s.useState(), d = t ?? o, u = n ?? i, m = x({
    open: d,
    onOpenChange: u
  }), h = m.context, w = N(h, {
    enabled: t == null
  }), _ = S(h, {
    outsidePress: !1,
    outsidePressEvent: "mousedown"
  }), E = R(h), g = y([w, _, E]);
  return s.useMemo(
    () => ({
      open: d,
      setOpen: u,
      ...g,
      ...m,
      labelId: r,
      descriptionId: c,
      setLabelId: a,
      setDescriptionId: f
    }),
    [d, u, g, m, r, c]
  );
}
const p = () => {
  const e = s.useContext(b);
  if (e == null)
    throw new Error("Modal components must be wrapped in <Modal />");
  return e;
};
function B({
  children: e,
  ...t
}) {
  const n = k(t);
  return /* @__PURE__ */ l(b.Provider, { value: n, children: e });
}
const U = s.forwardRef(function(e, t) {
  const { context: n, ...o } = p(), i = P([o.refs.setFloating, t]);
  if (!n.open)
    return null;
  const { overlayBackground: r, ...a } = e, c = I("grid place-items-center", {
    [`${r}`]: r,
    "bg-black sm:bg-black/[.8]": !r
  });
  return /* @__PURE__ */ l($, { children: /* @__PURE__ */ l(F, { className: c, lockScroll: !0, children: /* @__PURE__ */ l(T, { context: n, children: /* @__PURE__ */ l(
    "div",
    {
      ref: i,
      "aria-labelledby": o.labelId,
      "aria-describedby": o.descriptionId,
      ...o.getFloatingProps(a),
      children: a.children
    }
  ) }) }) });
}), j = s.forwardRef(function({ children: e, ...t }, n) {
  const { setLabelId: o } = p(), i = v();
  return s.useLayoutEffect(() => (o(i), () => o(void 0)), [i, o]), /* @__PURE__ */ l("h1", { ...t, ref: n, id: i, children: e });
}), G = s.forwardRef(function({ children: e, ...t }, n) {
  const { setDescriptionId: o } = p(), i = v();
  return s.useLayoutEffect(() => (o(i), () => o(void 0)), [i, o]), /* @__PURE__ */ l("div", { ...t, ref: n, id: i, children: e });
}), H = s.forwardRef(function(e, t) {
  const { setOpen: n } = p(), { trigger: o, className: i, ...r } = e, a = s.useCallback(() => n(!1), [n]);
  return /* @__PURE__ */ l("div", { className: i, children: s.cloneElement(o, {
    ref: t,
    onClick: a,
    ...r
  }) });
});
/*!
  @versini/ui-spacing v1.0.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_SPACING__ || (window.__VERSINI_UI_SPACING__ = {
    version: "1.0.0",
    buildTime: "12/25/2024 10:51 AM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const V = (e) => {
  let t = "";
  if (typeof e == "number" || typeof e == "string")
    t = "m-" + e;
  else {
    const n = [];
    (e == null ? void 0 : e.t) !== void 0 && n.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && n.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && n.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && n.push(`ml-${e.l}`), t = n.join(" ");
  }
  return t;
}, q = ({
  children: e,
  fill: t,
  viewBox: n,
  className: o,
  defaultViewBox: i,
  defaultClassName: r,
  spacing: a,
  title: c,
  semantic: f = !1,
  ...d
}) => {
  const u = V(a), m = I(
    u,
    o || r
  );
  return /* @__PURE__ */ M(C, { children: [
    /* @__PURE__ */ l(
      "svg",
      {
        xmlns: "http://www.w3.org/2000/svg",
        className: m,
        viewBox: n || i,
        fill: t || "currentColor",
        role: "img",
        "aria-hidden": !f,
        focusable: !1,
        ...d,
        children: e
      }
    ),
    c && f && /* @__PURE__ */ l("span", { className: "sr-only", children: c })
  ] });
};
/*!
  @versini/ui-private v1.7.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_PRIVATE__ || (window.__VERSINI_UI_PRIVATE__ = {
    version: "1.7.0",
    buildTime: "12/25/2024 10:51 AM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
export {
  B as Modal,
  H as ModalClose,
  U as ModalContent,
  G as ModalDescription,
  j as ModalHeading,
  q as SvgIcon
};
